/************************************************************
	
MCU: STC89C51
GSM MODULE: SIM900/SIM900A

*************************************************************/
#include <REG51.H>
#include <string.H>
#include <intrins.h>
#define uchar unsigned char
#define uint unsigned int

#define FOSC_110592M
//#define FOSC_12M
sbit P10=P1^0;
sbit P11=P1^1;
sbit P12=P1^2;
sbit P13=P1^3;
sbit P14=P1^4;
sbit P15=P1^5;
	
unsigned int  rec_data_len_uart=0;    
unsigned char idata Buffer_Uart0_Rec[25]={0};		
   
void SerialInti()  //9600 
{
	TMOD=0x20;

#ifdef FOSC_12M		   
	TH1=0xf3;
	TL1=0xf3;	
#else 	
	TH1=0xfd;
	TL1=0xfd;
#endif 
	
	TR1=1;
	SM0=0;
	SM1=1;
	REN=1;
	EA=1;
	ES=1;
}
unsigned char hand(unsigned char *data_source,unsigned char *ptr)
{
	if(strstr(data_source,ptr)!=NULL)
		return 1;
	else
		return 0;
}
void clear_rec_data()
{
	uchar i,temp_len;
	temp_len=strlen(Buffer_Uart0_Rec);
	if(temp_len>25)
	{
		temp_len=25;
	}
	for(i=0;i<temp_len;i++)
	{
		Buffer_Uart0_Rec[i]='\0';	
	}
	rec_data_len_uart=0;
}


void Serial_interrupt() interrupt 4 
{
	unsigned char temp_rec_data_uart0;	
	temp_rec_data_uart0 = SBUF;
	RI=0;
	Buffer_Uart0_Rec[rec_data_len_uart]=temp_rec_data_uart0;	
	rec_data_len_uart++;
	if(rec_data_len_uart>24)
	{
		rec_data_len_uart=0; 	
	}	
}
void Uart1Send(uchar c)
{
	SBUF=c;
	while(!TI);
	TI=0;	
}

void Uart1Sends(uchar *str)
{
	while(*str!='\0')
	{
		SBUF=*str;
		while(!TI);
		TI=0;
		str++;
	}
}

void DelaySec(int sec)
{
	uint i , j= 0;
	for(i=0; i<sec; i++)
	{
		for(j=0; j<65535; j++)
		{	
		}
	}
}
void main()
{
	uchar i = 0;
	SerialInti();						  //9600 
    DelaySec(10);						 // wait for regist the net
    P14=1;		 
		
    Uart1Sends("ATD18846920088;\r\n");	//make a call to 18846920088
    DelaySec(5);
    Uart1Sends("ATH\r\n");			// end the call 
  
    while(1);		   // end
}
